#include <cstring>
#include <iostream>

#include "string_holder.hxx"

// Initialize empty String_Holder
String_Holder::String_Holder()
  : length(0),
    characters{0}
{ }

// Initialize from null-terminated string
String_Holder::String_Holder(const char* string)
  : String_Holder(string, std::strlen(string))
{}

// Initialize from char array and length
String_Holder::String_Holder(const char* string, int len)
  : length(len),
    characters{0}
{
    // copy over values
    for (int i=0; i < length; i++) {
        characters[i] = string[i];
    }
}

// Copy constructor
String_Holder::String_Holder(const String_Holder& other)
  : String_Holder(other.characters, other.length)
{}

int String_Holder::size() const {
    return length;
}

char String_Holder::char_at(int n) const {
    return characters[n];
}

std::ostream& operator<<(std::ostream& os, const String_Holder& str) {
    os << "\"";
    for (int i=0; i<str.length; i++) {
        os << str.characters[i];
    }
    os << "\"";
    return os;
}

int main() {
    std::cout << "Program started!\n";

    String_Holder str("Test String");

    std::cout << "String characters are: " << str << "\n";

    return 0;
}
